---------------------------------
--Loading Function             --
---------------------------------
function Perl_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");

	-- Blizz Player Frame Events
	PlayerFrame:UnregisterEvent("UNIT_LEVEL");
	PlayerFrame:UnregisterEvent("UNIT_COMBAT");
	PlayerFrame:UnregisterEvent("UNIT_SPELLMISS");
	PlayerFrame:UnregisterEvent("UNIT_PVP_UPDATE");
	PlayerFrame:UnregisterEvent("UNIT_MAXMANA");
	PlayerFrame:UnregisterEvent("PLAYER_ENTER_COMBAT");
	PlayerFrame:UnregisterEvent("PLAYER_LEAVE_COMBAT");
	PlayerFrame:UnregisterEvent("PLAYER_UPDATE_RESTING");
	PlayerFrame:UnregisterEvent("PARTY_MEMBERS_CHANGED");
	PlayerFrame:UnregisterEvent("PARTY_LEADER_CHANGED");
	PlayerFrame:UnregisterEvent("PARTY_LOOT_METHOD_CHANGED");
	PlayerFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
	PlayerFrame:UnregisterEvent("PLAYER_REGEN_DISABLED");
	PlayerFrame:UnregisterEvent("PLAYER_REGEN_ENABLED");
	PlayerFrameHealthBar:UnregisterEvent("UNIT_HEALTH");
	PlayerFrameHealthBar:UnregisterEvent("UNIT_MAXHEALTH");
	-- ManaBar Events
	PlayerFrameManaBar:UnregisterEvent("UNIT_MANA");
	PlayerFrameManaBar:UnregisterEvent("UNIT_RAGE");
	PlayerFrameManaBar:UnregisterEvent("UNIT_FOCUS");
	PlayerFrameManaBar:UnregisterEvent("UNIT_ENERGY");
	PlayerFrameManaBar:UnregisterEvent("UNIT_HAPPINESS");
	PlayerFrameManaBar:UnregisterEvent("UNIT_MAXMANA");
	PlayerFrameManaBar:UnregisterEvent("UNIT_MAXRAGE");
	PlayerFrameManaBar:UnregisterEvent("UNIT_MAXFOCUS");
	PlayerFrameManaBar:UnregisterEvent("UNIT_MAXENERGY");
	PlayerFrameManaBar:UnregisterEvent("UNIT_MAXHAPPINESS");
	PlayerFrameManaBar:UnregisterEvent("UNIT_DISPLAYPOWER");
	-- UnitFrame Events
	PlayerFrame:UnregisterEvent("UNIT_NAME_UPDATE");
	PlayerFrame:UnregisterEvent("UNIT_PORTRAIT_UPDATE");
	PlayerFrame:UnregisterEvent("UNIT_DISPLAYPOWER");
	PlayerFrame:Hide();

	-- Blizz Pet Frame Events
	PetFrame:UnregisterEvent("UNIT_COMBAT");
	PetFrame:UnregisterEvent("UNIT_SPELLMISS");
	PetFrame:UnregisterEvent("UNIT_AURA");
	PetFrame:UnregisterEvent("PLAYER_PET_CHANGED");
	PetFrame:UnregisterEvent("PET_ATTACK_START");
	PetFrame:UnregisterEvent("PET_ATTACK_STOP");
	PetFrame:UnregisterEvent("UNIT_HAPPINESS");
	PetFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
	PetFrame:Hide();

	-- Blizz Target Frame Events
	TargetFrame:UnregisterEvent("UNIT_HEALTH");
	TargetFrame:UnregisterEvent("UNIT_LEVEL");
	TargetFrame:UnregisterEvent("UNIT_FACTION");
	TargetFrame:UnregisterEvent("UNIT_DYNAMIC_FLAGS");
	TargetFrame:UnregisterEvent("UNIT_CLASSIFICATION_CHANGED");
	TargetFrame:UnregisterEvent("PLAYER_PVPLEVEL_CHANGED");
	TargetFrame:UnregisterEvent("PLAYER_TARGET_CHANGED");
	TargetFrame:UnregisterEvent("PARTY_MEMBERS_CHANGED");
	TargetFrame:UnregisterEvent("PARTY_LEADER_CHANGED");
	TargetFrame:UnregisterEvent("PARTY_MEMBER_ENABLE");
	TargetFrame:UnregisterEvent("PARTY_MEMBER_DISABLE");
	TargetFrame:UnregisterEvent("UNIT_AURA");
	TargetFrame:UnregisterEvent("PLAYER_FLAGS_CHANGED");
	ComboFrame:UnregisterEvent("PLAYER_TARGET_CHANGED");
	ComboFrame:UnregisterEvent("PLAYER_COMBO_POINTS");
	TargetFrameHealthBar:UnregisterEvent("UNIT_HEALTH");
	TargetFrameHealthBar:UnregisterEvent("UNIT_MAXHEALTH");
	-- ManaBar Events
	TargetFrameManaBar:UnregisterEvent("UNIT_MANA");
	TargetFrameManaBar:UnregisterEvent("UNIT_RAGE");
	TargetFrameManaBar:UnregisterEvent("UNIT_FOCUS");
	TargetFrameManaBar:UnregisterEvent("UNIT_ENERGY");
	TargetFrameManaBar:UnregisterEvent("UNIT_HAPPINESS");
	TargetFrameManaBar:UnregisterEvent("UNIT_MAXMANA");
	TargetFrameManaBar:UnregisterEvent("UNIT_MAXRAGE");
	TargetFrameManaBar:UnregisterEvent("UNIT_MAXFOCUS");
	TargetFrameManaBar:UnregisterEvent("UNIT_MAXENERGY");
	TargetFrameManaBar:UnregisterEvent("UNIT_MAXHAPPINESS");
	TargetFrameManaBar:UnregisterEvent("UNIT_DISPLAYPOWER");
	-- UnitFrame Events
	TargetFrame:UnregisterEvent("UNIT_NAME_UPDATE");
	TargetFrame:UnregisterEvent("UNIT_PORTRAIT_UPDATE");
	TargetFrame:UnregisterEvent("UNIT_DISPLAYPOWER");
	TargetFrame:Hide();

	-- Blizz Party Events
	for num = 1, 4 do
		frame = getglobal("PartyMemberFrame"..num);
		HealthBar = getglobal("PartyMemberFrame"..num.."HealthBar");
		ManaBar = getglobal("PartyMemberFrame"..num.."ManaBar");
		frame:UnregisterEvent("PARTY_MEMBERS_CHANGED");
		frame:UnregisterEvent("PARTY_LEADER_CHANGED");
		frame:UnregisterEvent("PARTY_MEMBER_ENABLE");
		frame:UnregisterEvent("PARTY_MEMBER_DISABLE");
		frame:UnregisterEvent("PARTY_LOOT_METHOD_CHANGED");
		frame:UnregisterEvent("UNIT_PVP_UPDATE");
		frame:UnregisterEvent("UNIT_AURA");
		-- HealthBar Events
		HealthBar:UnregisterEvent("UNIT_HEALTH");
		HealthBar:UnregisterEvent("UNIT_MAXHEALTH");
		-- ManaBar Events
		ManaBar:UnregisterEvent("UNIT_MANA");
		ManaBar:UnregisterEvent("UNIT_RAGE");
		ManaBar:UnregisterEvent("UNIT_FOCUS");
		ManaBar:UnregisterEvent("UNIT_ENERGY");
		ManaBar:UnregisterEvent("UNIT_HAPPINESS");
		ManaBar:UnregisterEvent("UNIT_MAXMANA");
		ManaBar:UnregisterEvent("UNIT_MAXRAGE");
		ManaBar:UnregisterEvent("UNIT_MAXFOCUS");
		ManaBar:UnregisterEvent("UNIT_MAXENERGY");
		ManaBar:UnregisterEvent("UNIT_MAXHAPPINESS");
		ManaBar:UnregisterEvent("UNIT_DISPLAYPOWER");
		-- UnitFrame Events
		frame:UnregisterEvent("UNIT_NAME_UPDATE");
		frame:UnregisterEvent("UNIT_PORTRAIT_UPDATE");
		frame:UnregisterEvent("UNIT_DISPLAYPOWER");
	end
	HidePartyFrame();


end
---------------------------------
--Smooth Health Bar Color      --
---------------------------------
function Perl_SetSmoothBarColor (bar, refbar, alpha)
	if (not refbar) then
		refbar = bar;
	end
	if (not alpha) then
		alpha = 1;
	end
	if (bar) then
		local barmin, barmax = refbar:GetMinMaxValues();
		if (barmin == barmax) then
			return false;
		end
		local percentage = refbar:GetValue()/(barmax-barmin);

		local r, g, b;
		if (Perl_Config.ClassicHealthBar == 1) then
			if (percentage < 0.5) then
				r = 1;
				g = 2*percentage;
				b = 0;
			else
				g = 1;
				r = 2*(1 - percentage);
				b = 0;
			end
		else
			r = Perl_Config.ColourHealthEmpty.r + ((Perl_Config.ColourHealthFull.r - Perl_Config.ColourHealthEmpty.r) * percentage);
			g = Perl_Config.ColourHealthEmpty.g + ((Perl_Config.ColourHealthFull.g - Perl_Config.ColourHealthEmpty.g) * percentage);
			b = Perl_Config.ColourHealthEmpty.b + ((Perl_Config.ColourHealthFull.b - Perl_Config.ColourHealthEmpty.b) * percentage);
		end

		if ((r>=0) and (g>=0) and (b>=0) and (alpha>=0) and (r<=1) and (g<=1) and (b<=1) and (alpha<=1)) then
			bar:SetStatusBarColor(r, g, b, alpha);
		end
	else
		return false;
	end
end
--------

function Perl_UnitDebuffInformation(debuff)
	local i = 1;

	while UnitDebuff( "target", i ) do
		PerlBuffStatusTooltip:SetUnitDebuff("target", i );
		if PerlBuffStatusTooltipTextLeft1:GetText() == debuff then
			_, debuffApplications = UnitDebuff("target", i);
			return debuffApplications;
		end

		i = i + 1;
	end

	return 0;
end
---------------------------------
--Class Icon Location Functions--
---------------------------------
function Perl_ClassPos (class)
	if(class=="WARRIOR") then return 0,    0.25,    0,	0.25;	end
	if(class=="MAGE")    then return 0.25, 0.5,     0,	0.25;	end
	if(class=="ROGUE")   then return 0.5,  0.75,    0,	0.25;	end
	if(class=="DRUID")   then return 0.75, 1,       0,	0.25;	end
	if(class=="HUNTER")  then return 0,    0.25,    0.25,	0.5;	end
	if(class=="SHAMAN")  then return 0.25, 0.5,     0.25,	0.5;	end
	if(class=="PRIEST")  then return 0.5,  0.75,    0.25,	0.5;	end
	if(class=="WARLOCK") then return 0.75, 1,       0.25,	0.5;	end
	if(class=="PALADIN") then return 0,    0.25,    0.5,	0.75;	end
	return 0,1,0,1;
end

function Perl_Check_Raid()
	if (Perl_Config.ShowRaid == 1) then
		if (UnitName("raid1")) then
			if (not IsAddOnLoaded("Perl_RaidFrames")) then
				UIParentLoadAddOn("Perl_RaidFrames");
			end
		end
	end
end

function Perl_Options_SelectFrame(frame)
	if (perl_locked == 0) then
		Perl_OptionsFrame_SelectFrame(frame);
	end
end

function Perl_Toggle()
	if (perl_locked == 1) then
		Perl_UnlockFrames();
	else
		Perl_LockFrames();
	end
end

function Perl_UnlockFrames()
	if (not IsAddOnLoaded("Perl_Options")) then
		UIParentLoadAddOn("Perl_Options");
	end

	perl_locked = 0;
	if (Perl_RaidTitles) then
		Perl_RaidTitles();
	end

	if (IsAddOnLoaded("Perl_Options")) then
		if (Perl_FrameOptions_Frame) then
			Perl_FrameOptions_Frame:Show();
			Perl_FrameOptions_Frame:SetAlpha(0);
			Perl_FrameOptions_Frame.Fading = "in";
		end
	else
		EnableAddOn("Perl_Options");
		DEFAULT_CHAT_FRAME:AddMessage("X-Perl - Options window addon not enabled, enabling now. Will be active after /reloadui");
	end
end

function Perl_LockFrames()
	perl_locked = 1;
	if (Perl_FrameOptions_Frame) then
		--Perl_FrameOptions_Frame:Hide();
		Perl_FrameOptions_Frame.Fading = "out";
	end

	if (Perl_RaidTitles) then
		Perl_RaidTitles();
	end
end

function Perl_Error(error)
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFF0000X-Perl error|r - "..error);
end

-- Minimap Icon
function Perl_MinimapButton_OnClick()
	Perl_Toggle();
end

function Perl_MinimapButton_OnEnter()
end

function Perl_MinimapButton_Init()
	if(Perl_Config.MinimapButtonShown == 1) then
		Perl_MinimapButton_Frame:Show();
	else
		Perl_MinimapButton_Frame:Hide();
	end
end

function Perl_MinimapButton_UpdatePosition()
	Perl_MinimapButton_Frame:SetPoint(
		"TOPLEFT",
		"Minimap",
		"TOPLEFT",
		54 - (78 * cos(Perl_Config.MinimapButtonPosition)),
		(78 * sin(Perl_Config.MinimapButtonPosition)) - 55
	);
	Perl_MinimapButton_Init();
end

function Perl_MinimapButton_Dragging()

    local xpos,ypos = GetCursorPosition();
    local xmin,ymin = Minimap:GetLeft(), Minimap:GetBottom();

    xpos = xmin-xpos/UIParent:GetScale()+70;
    ypos = ypos/UIParent:GetScale()-ymin-70;

    Perl_MinimapButton_SetPosition(math.deg(math.atan2(ypos,xpos)));
end

function Perl_MinimapButton_SetPosition(v)
    if(v < 0) then
        v = v + 360;
    end

    Perl_Config.MinimapButtonPosition = v;
    Perl_MinimapButton_UpdatePosition();
end

function Perl_MinimapButton_OnEnter()
    GameTooltip:SetOwner(this, "ANCHOR_LEFT");
    GameTooltip:SetText(Perl_Version, 1, 1, 1);
    GameTooltip:AddLine(PERL_MINIMAP_HELP1);
    GameTooltip:AddLine(PERL_MINIMAP_HELP2);
    GameTooltip:Show();
end

------ Code Performance Timer
-- PerlTimer(true) - start it
-- PerlTimer(false, "Filename:Line") - at various suspect places
-- When a time of more than 0.01 seconds occurs, before and after text will be displayed.
-- Obviously, this is for identify performance issues in SMALL bits of code that should execute very fast
--[[
perlTimerCount = 0;
function PerlTimer(start, text)
	local now = GetTime();

	if (not start) then
		if (now - perlTimerStart >= 0.01) then
			perlTimerCount = perlTimerCount + 1;
			ChatFrame7:AddMessage(string.format("X-Perl - Delay No. %d: %.2f seconds between:", perlTimerCount, now - perlTimerStart));
			ChatFrame7:AddMessage("             "..perlTimerTitle1);
			ChatFrame7:AddMessage("             "..text);
		end
	end

	perlTimerStart = now;
	perlTimerTitle1 = text;
end
]]
