﻿--[[
Localisation file

]]

Perl_ProductName	= "|cFFD00000X-Perl|r UnitFrames";
Perl_Author		= "|cFFFF8080Zek|r";
Perl_Description        = Perl_ProductName.." by "..Perl_Author;
Perl_VersionNumber      = "1.6.6";
Perl_Version		= Perl_Description.." - "..Perl_VersionNumber;
Perl_LongDescription	= "Replaces the normal unit, party, target,\13pet and target-of-target.";
Perl_ModMenuIcon	= "Interface\\Icons\\INV_Misc_Gem_Pearl_02";

PERL_MINIMAP_HELP1	= "Left click to toggle X-Perl options";
PERL_MINIMAP_HELP2	= "Right click to drag this icon";

PERL_LOC_CLASS_WARRIOR = "Warrior";
PERL_LOC_CLASS_MAGE = "Mage";
PERL_LOC_CLASS_ROGUE = "Rogue";
PERL_LOC_CLASS_DRUID = "Druid";
PERL_LOC_CLASS_HUNTER = "Hunter";
PERL_LOC_CLASS_SHAMAN = "Shaman";
PERL_LOC_CLASS_PRIEST = "Priest";
PERL_LOC_CLASS_WARLOCK = "Warlock";
PERL_LOC_CLASS_PALADIN = "Paladin";
PERL_TYPE_NOT_SPECIFIED = "Not specified";

PERL_TOOLTIP_ASSISTING	= "Players Assisting:";
PERL_TOOLTIP_HEALERS	= "Healers Targetting Me:";
PERL_TOOLTIP_ALLONME	= "All Targetting Me:";
PERL_TOOLTIP_ENEMYONME	= "Enemy Targetting Me:";
PERL_TOOLTIP_HELP	= "Click to open real time view";

PERL_MAGIC = "Magic";
PERL_DISEASE = "Disease";
PERL_POISON = "Poison";
PERL_CURSE = "Curse";

BINDING_HEADER_PERL = "X-Perl Key Bindings"
BINDING_NAME_TOGGLERAID = "Toggle Raid Windows";
BINDING_NAME_TOGGLEOPTIONS = "Toggle Options Window";

if ( GetLocale() == "frFR" ) then
	PERL_LOC_CLASS_WARRIOR = "Guerrier";
	PERL_LOC_CLASS_MAGE = "Mage";
	PERL_LOC_CLASS_ROGUE = "Voleur";
	PERL_LOC_CLASS_DRUID = "Druide";
	PERL_LOC_CLASS_HUNTER = "Chasseur";
	PERL_LOC_CLASS_SHAMAN = "Chaman";
	PERL_LOC_CLASS_PRIEST = "Pr\195\170tre";
	PERL_LOC_CLASS_WARLOCK = "D\195\169moniste";
	PERL_LOC_CLASS_PALADIN = "Paladin";
	PERL_TYPE_NOT_SPECIFIED = "Non indiqu\195\169";

	PERL_MAGIC = "Magie";
	PERL_DISEASE = "Maladie";
	PERL_POISON = "Poison";
	PERL_CURSE = "Mal\195\169diction";
end
if ( GetLocale() == "koKR" ) then
	PERL_LOC_CLASS_WARRIOR = "전사";
	PERL_LOC_CLASS_MAGE = "마법사";
	PERL_LOC_CLASS_ROGUE = "도적";
	PERL_LOC_CLASS_DRUID = "드루이드";
	PERL_LOC_CLASS_HUNTER = "사냥꾼";
	PERL_LOC_CLASS_SHAMAN = "주술사";
	PERL_LOC_CLASS_PRIEST = "사제";
	PERL_LOC_CLASS_WARLOCK = "흑마법사";
	PERL_LOC_CLASS_PALADIN = "성기사";
end
if ( GetLocale() == "deDE") then
	PERL_LOC_CLASS_WARRIOR = "Krieger";
	PERL_LOC_CLASS_MAGE = "Magier";
	PERL_LOC_CLASS_ROGUE = "Schurke";
	PERL_LOC_CLASS_DRUID = "Druide";
	PERL_LOC_CLASS_HUNTER = "J\195\164ger";
	PERL_LOC_CLASS_SHAMAN = "Schamane";
	PERL_LOC_CLASS_PRIEST = "Priester";
	PERL_LOC_CLASS_WARLOCK = "Hexenmeister";
	PERL_LOC_CLASS_PALADIN = "Paladin";
	PERL_TYPE_NOT_SPECIFIED = "Nicht spezifiziert";

	PERL_MAGIC = "Magie";
	PERL_DISEASE = "Krankheit";
	PERL_POISON = "Gift";
	PERL_CURSE = "Fluch";
end
